

void setup_dice(CBaseEntity@ pActivator, CBaseEntity@ pCaller, USE_TYPE useType, float flValue) {
	g_Game.AlertMessage( at_console,"omg please work");

	CBaseEntity@ ent = null;
	do {
		@ent = g_EntityFuncs.FindEntityByTargetname(ent, "dice_button_*");
		if (ent !is null and ent.pev.frame == 0) {
			ent.pev.effects = EF_FRAMEANIMTEXTURES;
			ent.pev.frame = 0;
		}
	} while(ent !is null);
}

void dice_used(CBaseEntity@ pActivator, CBaseEntity@ pCaller, USE_TYPE useType, float flValue)
{
	g_Game.AlertMessage( at_console,"asdf " + pCaller.pev.targetname);
	
	string visible_face_name = "" + pCaller.pev.targetname + "_r";
	
	CBaseEntity@ face = g_EntityFuncs.FindEntityByTargetname(null, visible_face_name);
	
	face.pev.frame = (face.pev.frame + 1) % 6;
	face.pev.effects = EF_FRAMEANIMTEXTURES;
	
	if (is_valid_dice()) {
		g_EntityFuncs.FireTargets("dice_puzzle_solved", pActivator, pActivator, USE_TOGGLE, 0.0f, 0.0f);
	}
}

bool is_valid_dice() {

	array<CBaseEntity@> all_faces = {
		// pair = faces that oppose each other when the dice is folded up into a box
		g_EntityFuncs.FindEntityByTargetname(null, "dice_button_pair0_0_r"), 
		g_EntityFuncs.FindEntityByTargetname(null, "dice_button_pair0_1_r"),
		
		g_EntityFuncs.FindEntityByTargetname(null, "dice_button_pair1_0_r"),
		g_EntityFuncs.FindEntityByTargetname(null, "dice_button_pair1_1_r"),
		
		g_EntityFuncs.FindEntityByTargetname(null, "dice_button_pair2_0_r"),
		g_EntityFuncs.FindEntityByTargetname(null, "dice_button_pair2_1_r")
	};
	
	array<bool> is_number_used = {false, false, false, false, false, false};
	
	// all numbers should be used at least once
	for (uint i = 0; i < all_faces.size(); i++) {
		is_number_used[int(all_faces[i].pev.frame)] = true;
	}	
	for (uint i = 0; i < is_number_used.size(); i++) {
		if (!is_number_used[i]) {
			//g_Game.AlertMessage( at_console,"not all numbers used\n");
			return false;
		}
	}
	
	// opposite face pairs should add up to 7
	for (int i = 0; i < 6; i += 2) {
		int sum = int(all_faces[i].pev.frame + 1) + int(all_faces[i+1].pev.frame + 1);
		
		if (sum != 7) {
			//g_Game.AlertMessage( at_console,"sum is not 7 on some pair \n");
			return false;
		}
	}
	
	//g_Game.AlertMessage( at_console,"zomg u win \n");
	
	return true;
}